;***************************************
p_UART	equ	80h
;============================================
; -----	init RS232 --------------
; (B) = speed, (C) - Byte, (D) - INT, (E) - FIFO
; 6 - 19200
; 12 - 9600
; 24 - 4800
; 48 - 2400
; 96 - 1200
init_UART:
	ld	a, 80h		;DLAB=1
	out	(p_UART+3),a	;(3)=80h DLAB=1
	ld	a, 00h
	out	(p_UART+1),a	;(1)=00h
	ld	a, b		; SPEED
	out	(p_UART+0),a	;(0)=B
; 2) no paritet, 2 stop-bit, 8 bit
	ld	a, c
	and	7Fh		;DLAB=0
	out	(p_UART+3),a	;(03EFh)=03h
; 3) set INT
	ld	a, d		; 0 - disable INT
	out	(p_UART+1),a	;(1)=00h
; 4) reset and disable/enable FIFO
	ld	a, 07h		;reset FIFO
	out	(p_UART+2),a	;(2)=07h
	ld	a, e		; 0-disable/1-enable FIFO
	out	(p_UART+2),a	;(02EFh)=00h
; 5) /OUT2=0,/OUT1=0,/RTS=1,/DTR=1
	ld	a,03h
	out	(p_UART+4),a 	;(4)=03h
; 6) reset UART-ports
	in	a,(p_UART+0)	;<=(0)
	inc	a
	ret	z		;z=1 not UART
	in	a, (p_UART+5)	;<=(5)
	inc	a
	ret	z		;z=1 not UART
	inc	b
	in	a, (p_UART+6)	;<=(6)
	inc	a
	ret			;z=1 not UART
;  -------- end init UART -------
;-----------------------------------------------
; send byte (A) ->
send_A:	push	af
send_w:	chk_txd
	jr	z,send_w	;wait
	pop	af
	out	(p_UART+0),a
	ret
;-----------------------------------------------
; resive byte -> (A) with timeout (DE)
resv_A:	chk_rxd
	jr	z,resv_n
	in	a,(p_UART+0)
	or	a		;CY=0 OK
	ret
resv_n:	dec	de
	ld	a,d
	or	e
	jr	nz,resv_A	;wait
	scf			;CY=1 error
	ret
;-----------------------------------------------
; end uart.inc
